import { r as registerInstance, h, H as Host } from './index-cb74209c.js';
import { c as createColorClasses } from './theme-7dce6eff.js';
import { g as getIonMode } from './ionic-global-1b27992c.js';

const textCss = ":host(.ion-color){color:var(--ion-color-base)}";

const Text = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.color = undefined;
  }
  render() {
    const mode = getIonMode(this);
    return (h(Host, { class: createColorClasses(this.color, {
        [mode]: true,
      }) }, h("slot", null)));
  }
};
Text.style = textCss;

export { Text as ion_text };

//# sourceMappingURL=ion-text.entry.js.map