export declare class App {
  el: HTMLGlAppElement;
  /**
   * Application name in the main title bar.
   */
  readonly label: string;
  /**
   * Menu type. A value of `false` disables the menu, while a `custom` menu
   * type creates a menu slot.
   */
  readonly menu: "custom" | boolean;
  /**
   * Heading text for the menu.
   */
  readonly menuLabel: string;
  /**
   * Should the application use `ion-split-pane` to display the menu?
   */
  readonly splitPane: boolean;
  /**
   * What type of side menu to use, valid options are `push`, `overlay`, and `reveal`.
   */
  readonly menuType: "push" | "overlay" | "reveal";
  componentDidLoad(): void;
  private getMenu;
  private getMenuButton;
  private getMain;
  render(): any;
}
