import { EventEmitter } from "../../stencil-public-runtime";
import { Color } from "@ionic/core";
export declare class DrawToolbar {
  /**
   * Emitted when the user cancels the draw session.
   */
  glDrawCancel: EventEmitter;
  /**
   * Emitted when the user confirms the drawn features.
   */
  glDrawConfirm: EventEmitter;
  visible: boolean;
  featureCount: number;
  /**
   * Text for the cancel button.
   */
  readonly cancelText: string;
  /**
   * Background color for the toolbar.
   */
  readonly color: Color;
  /**
   * Text for the confirm button.
   */
  readonly confirmText: string;
  /**
   * Label for the toolbar.
   */
  readonly label: string;
  /**
   * ID of the map with the drawing session.
   *
   * This defaults to the empty string as when a gl-map element is created without an id, the mapId passed along the glDraw events defaults to the empty string.
   */
  readonly mapId: string;
  /**
   * Maximum number of features the user can draw.
   */
  readonly maxFeatures: number;
  /**
   * Minimum number of features the user must draw before confirming.
   */
  readonly minFeatures: number;
  handleDrawEnter(e: CustomEvent): void;
  handleDrawExit(e: CustomEvent): void;
  handleDrawCreate(e: CustomEvent): void;
  handleDrawDelete(e: CustomEvent): void;
  private cancel;
  private confirm;
  private callCancel;
  private callConfirm;
  render(): any;
}
