import { EventEmitter } from "../../stencil-public-runtime";
export declare class Facet {
  el: HTMLGlFacetElement;
  /**
   * Emitted when the facet is selected by the user.
   */
  glFormFacet: EventEmitter;
  /**
   * Show the detail arrow in the item.
   */
  readonly detail: boolean;
  /**
   * Image URL for the item.
   */
  readonly image: string;
  /**
   * Text for the item.
   */
  readonly label: string;
  /**
   * The value of the facet used to refer to it in fields and other
   * facets. When the facet is selected, the value is emitted as
   * part of the `glFormFacet` event.
   */
  readonly value: string;
  /**
   * Widget to use for displaying the facet. A value of `header` renders
   * an `ion-list-header` instead of an `ion-item`.
   */
  readonly widget: "header" | "item";
  private setFacet;
  private callSetFacet;
  render(): any;
}
