import { FormOptions } from "./interface";
export declare class FormController {
  /**
   * Display a form in a modal. If the form is canceled, it resolves to
   * `undefined`. If the form is submitted, it resolves to the GeoJSON
   * feature updated by the form.
   * @param feature The GeoJSON feature that the form will edit.
   * @param options Option object used to set the properties of the `gl-form`.
   */
  create(feature: {
    properties: {
      [key: string]: any;
    };
  }, options: FormOptions): Promise<any>;
}
