export declare class FormPage {
  el: HTMLGlFormPageElement;
  canSubmit: boolean;
  /**
   * Text for the back button.
   */
  readonly backText: string;
  /**
   * Facets for the page.
   */
  readonly facets: any[];
  /**
   * Fields for the page.
   */
  readonly fields: any[];
  /**
   * Currently-selected facet. It is used the set the CSS class of the page.
   */
  readonly formFacet: string;
  /**
   * Label text displayed in the form toolbar.
   */
  readonly label: string;
  /**
   * This is the root page in the form. If it is `true`, the back button
   * is not displayed.
   */
  readonly root: boolean;
  /**
   * Text for the submit button.
   */
  readonly submitText: string;
  /**
   * Text for the cancel button.
   */
  readonly cancelText: string;
  componentDidLoad(): void;
  updateValidationStatus(): Promise<void>;
  private validate;
  private cancel;
  private submit;
  private renderFacets;
  private renderFields;
  private renderOptions;
  private clickSubmit;
  private clickCancel;
  render(): any;
}
