import { ForwardGeocodeOptions, ReverseGeocodeOptions, GeocodeResponse } from "./geocode-interface";
/**
 * The start of a nominatim clients object interface
 * Based partially off of usage and partially off of
 * https://nominatim.org/release-docs/develop/api/Search/
 * https://nominatim.org/release-docs/develop/api/Reverse/
 *
 * More could definitely be added to it and if you (developer reading this in the future) need more options
 * feel free to add those to this interface.
 */
export interface NominatimClientOptions {
  addressdetails?: string;
  countrycodes?: string | string[];
  mode?: RequestMode;
  zoom?: string;
}
export declare class NominatimClient {
  forward(options: ForwardGeocodeOptions, clientOptions?: NominatimClientOptions): Promise<GeocodeResponse[]>;
  reverse(options: ReverseGeocodeOptions, clientOptions?: NominatimClientOptions): Promise<any>;
  formatResponse(res: any): GeocodeResponse[];
  formatResponseItem(item: any): GeocodeResponse;
  addParams(endpoint: string, params: any): string;
}
