export declare class LegendItem {
  el: HTMLGlLegendItemElement;
  visible: boolean;
  /**
   * The IDs of the style layers controlled by this legend item. If controls
   * which layers are toggled or on off by this legend item.
   */
  readonly layers: string | string[];
  /**
   * The URL of the image for the legend item.
   */
  readonly image: string;
  /**
   * Show a toggle switch to turn the corresponding layer on and off. If
   * it is `true`, `layers` and `styleId` must be provided.
   */
  readonly toggle: boolean;
  /**
   * ID of the `gl-style` containing the layers referenced in `layers`.
   */
  readonly styleId: string;
  /**
   * Widget used to render the legend item. The `divider` value renders an
   * `ion-list-divider` component suitable for grouping subsequent legend items.
   */
  readonly widget: "divider" | "item";
  componentWillLoad(): Promise<void>;
  handleStyleId(): Promise<void>;
  handleStyleAdded(e: CustomEvent): void;
  handleStyleUpdated(e: CustomEvent): void;
  private getStyle;
  private getVisible;
  private setVisible;
  private update;
  private onToggle;
  render(): any;
}
