export declare class Share {
  el: HTMLGlShareElement;
  /**
   * Height of the popup window in pixels.
   */
  readonly popupHeight: number;
  /**
   * Width of the popup window in pixels.
   */
  readonly popupWidth: number;
  /**
   * Title of the item being shared.
   */
  readonly shareTitle: string;
  /**
   * User attribution. It is used for sharing on Twitter.
   */
  readonly shareUser: string;
  /**
   * Hashtags for the post. It is used for sharing on Twitter.
   */
  readonly shareHashtags: string;
  /**
   * URL to share. If a URL is not provided, the current page URL is used.
   */
  readonly shareUrl: string;
  private constructShareUrl;
  private share;
  private openUrl;
  private closePopover;
  private clickShare;
  render(): any;
}
