export declare class TableExportButton {
  /**
   * If this is for a pdf export, the author variable of the pdf document.
   */
  readonly author?: string;
  /**
   * When the document is exported, what file name it should be saved as.
   */
  readonly filename: string;
  /**
   * The format in which the document should be exported, either csv or pdf.
   */
  readonly format: "csv" | "pdf";
  /**
   * The orientation of the exported document
   */
  readonly pageOrientation?: "landscape" | "portrait";
  /**
   * The subtitle of the document if the document is exported as a pdf
   */
  readonly pageSubtitle?: string;
  /**
   * The title of the document if the document is exported as a pdf.
   */
  readonly pageTitle?: string;
  /**
   * The id of the [table]{@link ../table} this export button is for.
   */
  readonly tableId?: string;
  /**
   * If this value is defined the application will attempt to send the contents of the pdf in a POST request to the specified
   * url when the export button is clicked, in addition to presenting it to the user for download.
   */
  readonly url?: string;
  /**
   * If true the JSX component for the table-export-button will expose a <slot /> for a custom button whereas otherwise it is this.format.toUpperCase()
   * aka CSV or PDF
   */
  readonly customButton: boolean;
  exportCtrl: HTMLGlTableExportControllerElement;
  private clickHandler;
  private buttonClicked;
  render(): any;
}
